CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  BUFFER_2K     = $800
  
  CR            = $0D
  LF            = $0A
  RESET_PIN     = 4 
  
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE
  
       
VAR

DAT
  ok            byte  "HTTP/1.1 200 OK", CR, LF, CR, LF, $0
       
                'Get a user's subscription
  getreg        byte  "GET /api/Subscribers/1 HTTP/1.1", CR, LF, {
}               byte  "Host: 192.168.1.104:8080", CR, LF, {
}               byte  "User-Agent: Wiz5200", CR, LF, CR, LF, $0

                'Register a user with the Message service
  register      byte  "POST /api/Subscribers HTTP/1.1", CR, LF, {
}               byte  "Host: 192.168.1.104:8080", CR, LF, {
}               byte  "User-Agent: Wiz5200", CR, LF, {
}               byte  "Content-Type: application/xml; charset=utf-8", CR, LF, {
}               byte  "Content-Length: 231", CR, LF, CR, LF
  msg1          byte  "<Subscriber  xmlns:i='http://www.w3.org/2001/XMLSchema-instance' ",{
}               byte  "xmlns='http://schemas.datacontract.org/2004/07/AgaveRobotics.Web.Demos.Model'>", {
}               byte  "<Id>0</Id>",    {
}               byte  "<Ip>192.168.1.110</Ip>", {
}               byte  "<Port>8081</Port>", {
}               byte  "<Username>W5200</Username>", {
}               byte  "</Subscriber>", $0

                'Send a message
  message       byte  "POST /api/Messages HTTP/1.1", CR, LF, {
}               byte  "Host: 192.168.1.104:8080", CR, LF, {
}               byte  "User-Agent: Wiz5200", CR, LF, {
}               byte  "Content-Type: application/xml; charset=utf-8", CR, LF, {
}               byte  "Content-Length: 239", CR, LF, CR, LF
  msg2          byte  "<Message  xmlns:i='http://www.w3.org/2001/XMLSchema-instance' ",{
}               byte  "xmlns='http://schemas.datacontract.org/2004/07/AgaveRobotics.Web.Demos.Model'>", {
}               byte  "<Id>0</Id>",    {
}               byte  "<From>W5200</From>", {
}               byte  "<To>spinneret</To>", {
}               byte  "<Content>Hi Spinneret from W5200.</Content>", {
}               byte  "</Message>", $0

  buff          byte  $0[BUFFER_2K]
  null          long  $00
  
OBJ
  pst           : "Parallax Serial Terminal"
  sock          : "Socket"
  wiz           : "W5200" 



 
PUB Main | buffer, receiving, totalBytes
  pst.Start(115_200)
  pause(500)

  'wiz.QS_Init
  wiz.HardReset(WIZ#WIZ_RESET)
  wiz.Start(WIZ#SPI_CS, WIZ#SPI_SCK, WIZ#SPI_MOSI, WIZ#SPI_MISO)
  
  'Set network parameters
  wiz.SetCommonnMode(0)
  wiz.SetGateway(192, 168, 1, 1)
  wiz.SetSubnetMask(255, 255, 255, 0)
  wiz.SetIp(192, 168, 1, 110)
  wiz.SetMac($00, $08, $DC, $16, $F8, $01)

  'pst.dec(strsize(@msg1))
  'return 
  
  pst.str(string("Initialize", CR))
  sock.Init(0, TCP, 8081)

  ' IP address of the Message service
  sock.RemoteIp(192,168,1,104) 
  sock.RemotePort(8080)

  'register
  'getreg
  RegisterRequest(@register)
  GetResponse

  'Listen for messages
  Listener

   
PUB RegisterRequest(req) | bytesSent
  pst.str(string(CR, "Register with the Message Service", CR))
  sock.Open
  pause(200)
  sock.Connect
  pause(200)
  
  'Connection?
  repeat until sock.Connected
    pause(100)

  pst.str(string("Send Registration", CR)) 
  bytesSent := sock.Send(req, strsize(req))
  pst.str(string("Bytes Sent: "))
  pst.dec(bytesSent)
  pst.char(13)

  
PUB GetResponse | bytesToRead 
  bytesToRead~
  
  repeat until (bytesToRead := sock.Available)
   
  'Check for a timeout
  if(bytesToRead < 0)
    pst.str(string("Timeout", CR))
    return
 
  if(bytesToRead > 0) 
    'Get the Rx buffer  
    sock.Receive(@buff, bytesToRead)
    pst.str(@buff)
    sock.Disconnect

PUB Listener | bytesToRead

  pst.str(string("Start Listener", CR))
  bytesToRead~
  
  repeat
    sock.Open
    sock.Listen
    'Connection?
    repeat until sock.Connected
    pause(500)
    repeat until (bytesToRead := sock.Available)
   
    'Check for a timeout
    if(bytesToRead < 0)
      sock.Disconnect
      bytesToRead~
      next

    'Process request
    if(bytesToRead > 0)   
      sock.Receive(@buff, bytesToRead)
      pst.str(@buff)
      sock.Send(@ok, strsize(@ok))
      
    sock.Disconnect
    bytesToRead~

    
    
  
PUB PrintNameValue(name, value, digits) | len
  len := strsize(name)
  
  pst.str(name)
  repeat 30 - len
    pst.char($2E)
  if(digits > 0)
    pst.hex(value, digits)
  else
    pst.dec(value)
  pst.char(CR)


PUB DisplayMemory(addr, len, isHex) | j
  pst.str(string(13,"-----------------------------------------------------",13))
  pst.str(string(13, "      "))
  repeat j from 0 to $F
    pst.hex(j, 2)
    pst.char($20)
  pst.str(string(13, "      ")) 
  repeat j from 0 to $F
    pst.str(string("-- "))

  pst.char(13) 
  repeat j from 0 to len
    if(j == 0)
      pst.hex(0, 4)
      pst.char($20)
      pst.char($20)
      
    if(isHex)
      pst.hex(byte[addr + j], 2)
    else
      pst.char($20)
      if(byte[addr+j] == 0)
        pst.char($20)
      pst.char(byte[addr+j])

    pst.char($20) 
    if((j+1) // $10 == 0) 
      pst.char($0D)
      pst.hex(j+1, 4)
      pst.char($20)
      pst.char($20)  
  pst.char(13)
  
  pst.char(13)
  pst.str(string("Start: "))
  pst.dec(addr)
  pst.str(string(" Len: "))
  pst.dec(len)
  pst.str(string(13,"-----------------------------------------------------",13,13))
      
PUB PrintIp(addr) | i
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)
    else
      pst.char($0D)
  
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return